/***********************************************************************
*                                                                      *
*  H E A D E R - F I L E                                               *
*                                                                      *
*  F U L L - C A N   C O N T R O L L E R                               *
*                                                                      *
************************************************************************/


   /* Erstes Byte im internen Speicher des 81C91 das fr CAN-Objekte   */
   /* benutzt werden darf. Die interne Start-Adresse des ersten        */
   /* Objektes entspricht CONTR_BUF_START_ADR                          */
   #define CONTR_BUF_START_ADR  0x80

   /* Letztes Byte im internen Speicher des 81C91 das fr Objekte      */
   /* benutzt werden darf                                              */
   #define CONTR_BUF_END_ADR  0xF8

   /* Die Lnge einesr Meldung im internen Speicher des 81C91          */
   /* (genaueres siehe  Siemens 81C91 Manual)                          */
   #define MESSAGE_SIZE  0x08


   /* Returnwerte von c_get_int_typ */
   enum interrupt_t {no_int, error_int, obj_int};

   /* Returnwerte von c_get_status  */
   enum can_bus_stat_t {error_active, error_passive, bus_off};

byte c_hw_init (byte bit_length_1_reg,
                byte bit_length_2_reg,
                byte output_control_reg,
                byte sleep_and_br_prescale);

void c_init_clock_cont_reg (byte clock_cont_reg);

void c_init_obj (unsigned int ident,
                 byte         data_len,
                 byte         obj_typ,
                 byte         obj_adr);

void c_start (void);

void c_stop (void);

void c_read_obj (byte obj_adr,
                 byte xdata *arr);

byte c_send_obj (byte obj_adr,
                 byte remote,
                 byte xdata *arr);

byte c_write_obj (byte obj_adr,
                  byte xdata *arr);

void c_write_end_mark (byte obj_adr);

enum interrupt_t c_get_int_typ (void);

byte c_get_obj_int_adr (void);

void c_receipt_obj_int (byte obj_adr);

void c_receipt_error_int (void);

enum can_bus_stat_t c_get_status (void);


